///////////////////////////////////////////////////////////////////////////////
//
//  Vom Xbase++ FormDesigner generierter Klassen Code
//    Erstellt am: 20.04.99 Zeit: 21:17:27
//
//  Contents  :
//    Diese Datei enthlt das Gerst zur Implementierung der Nutzungsebene.
//    Daher kann und soll diese Datei verndert werden.
//
///////////////////////////////////////////////////////////////////////////////

#include "Gra.ch"
#include "Xbp.ch"
#include "Common.ch"
#include "Appevent.ch"
#include "Font.ch"

******************************************************************************
* Von der Darstellungsklasse abgeleitete Klasse zur Implementierung der
* Programmlogik. Die Instanzvariablen der einzelnen Objekte sind in der
* Klasse _NewForm deklariert.
******************************************************************************
/*
   Derived iVars :

      VAR SelBox1
      VAR Sel1Input
      VAR Sel1Add
      VAR SelBox2
      VAR Sel2Input
      VAR Sel2Add
      VAR SaveIt
      VAR ButtonCancel
      VAR Static1
      VAR Static2

*/
CLASS Sample1 FROM _NewForm
   VAR oReg

   EXPORTED:
      METHOD init
      METHOD create
      METHOD AddItem
      METHOD SaveSettings

ENDCLASS

******************************************************************************
* Formular initialisieren
******************************************************************************
METHOD Sample1:init( oParent, oOwner, aPos, aSize, aPP, lVisible )

   * call init method of the super class
   ::_NewForm:init( oParent, oOwner, aPos, aSize, aPP, lVisible )

   ::Sel1Add:Activate := { |xNil1, xNil2, oSelf| oSelf:SetOwner():SetOwner():AddItem( 1 ) }
   ::Sel2Add:Activate := { |xNil1, xNil2, oSelf| oSelf:SetOwner():SetOwner():AddItem( 2 ) }
   ::SaveIt:Activate  := { |xNil1, xNil2, oSelf| oSelf:SetOwner():SetOwner():SaveSettings() }

RETURN self

******************************************************************************
* Systemresourcen anfordern
******************************************************************************
METHOD Sample1:create( oParent, oOwner, aPos, aSize, aPP, lVisible )
   LOCAL aKeys, aSel1, aSel2, nI, nLen

   ::oReg := XbpReg():NEW( "HKEY_LOCAL_MACHINE\SOFTWARE\SAMPLE1" )

   * Methode der Superklasse rufen
   ::_NewForm:create( oParent, oOwner, aPos, aSize, aPP, lVisible )
   ::SetTitle( "Registry sample program 1" )

   // Test if key already exists, if not, create it and initialize with default
   // selection entries
   If ! ::oReg:Status
      ::oReg:Create()
      ::oReg:NewKey( "Selection1" )
      ::oReg:NewKey( "Selection2" )
      ::oReg:MoveDown( "Selection1" )
      ::oReg:SetValue( "001", "Listbox 1 entry 1" )
      ::oReg:SetValue( "002", "Listbox 1 entry 2" )
      ::oReg:SetValue( "003", "Listbox 1 entry 3" )
      ::oReg:SetValue( "004", "Listbox 1 entry 4" )
      ::oReg:SetValue( "005", "Listbox 1 entry 5" )
      ::oReg:MoveUp()
      ::oReg:MoveDown( "Selection2" )
      ::oReg:SetValue( "001", "Listbox 2 entry 1" )
      ::oReg:SetValue( "002", "Listbox 2 entry 2" )
      ::oReg:SetValue( "003", "Listbox 2 entry 3" )
      ::oReg:SetValue( "004", "Listbox 2 entry 4" )
      ::oReg:SetValue( "005", "Listbox 2 entry 5" )
      ::oReg:MoveUp()
   EndIF

   ::oReg:MoveDown( "Selection1" )
   aSel1 := ::oReg:ValueList()

   nLen := LEN(aSel1)

   For nI := 1 TO nLen
      ::SelBox1:AddItem( aSel1[nI,2] )
   Next

   ::oReg:MoveUp()
   ::oReg:MoveDown( "Selection2" )
   aSel2 := ::oReg:ValueList()
   ::oReg:MoveUp()

   nLen := LEN(aSel2)
   For nI := 1 TO nLen
      ::SelBox2:AddItem( aSel2[nI,2] )
   Next
   ::SelBox2:XbpSle:SetData( aSel2[1,2] )

   * Formular anzeigen
   ::show()

RETURN self

/*
   Add item to listbox or combobox
*/
METHOD Sample1:AddItem( nSel )
   LOCAL cItem, lRet := .F.

   DEFAULT nSel TO 0

   DO CASE
      CASE nSel = 1
         If ! EMPTY( cItem := TRIM( ::Sel1Input:GetData() ) )
            ::SelBox1:AddItem( cItem )
            lRet := .T.
         EndIF

      CASE nSel = 2
         If ! EMPTY( cItem := TRIM( ::Sel2Input:GetData() ) )
            ::SelBox2:xbpListBox:AddItem( cItem )
            ::SelBox2:ListBoxFocus(.T.)
            lRet := .T.
         EndIF
   ENDCASE

RETURN lRet

/*
   Save contents of both listboxes to registry
*/
METHOD Sample1:SaveSettings
   LOCAL nCount1 := ::SelBox1:NumItems()
   LOCAL nCount2 := ::SelBox2:XbpListBox:NumItems()
   LOCAL nI := 0, cItem := ""

   If nCount1 > 0
      ::oReg:MoveDown( "Selection1" )
      For nI := 1 TO nCount1
         cItem := ::SelBox1:GetItem(nI)
         ::oReg:SetValue( STRZERO( nI, 3, 0 ), cItem  )
      Next
      ::oReg:MoveUp()
   EndIF

   If nCount2 > 0
      ::oReg:MoveDown( "Selection2" )
      For nI := 1 TO nCount1
         cItem := ::SelBox2:GetItem(nI)
         ::oReg:SetValue( STRZERO( nI, 3, 0 ), cItem )
      Next
      ::oReg:MoveUp()
   EndIF

RETURN NIL


******************************************************************************
* Main Prozedur zum Testen des Formulars
******************************************************************************
PROCEDURE Main

   LOCAL nEvent, oXbp, mp1, mp2

   Sample1():New():Create()

   nEvent := xbe_None
   WHILE nEvent != xbeP_Close
      nEvent := AppEvent ( @mp1, @mp2, @oXbp )
      oXbp:HandleEvent ( nEvent, mp1, mp2 )
      IF nEvent == xbeP_Quit
         QUIT   // AppQuit()
      ENDIF
   ENDDO

RETURN

/*
   EMPTY APPSYS
*/
PROC APPSYS
RETURN

* Programmcode fr die Implementierungsebene der Klasse einfgen
#include "_SAMPLE1.PRG"

//EOF
/////